<!DOCTYPE html>

<html lang="en">
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width">
	<title>Plaiframe Docs Source: medley.js</title>

	<!--[if lt IE 9]>
	<script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->
	<link type="text/css" rel="stylesheet" href="styles/sunlight.default.css">

	<link type="text/css" rel="stylesheet" href="styles/site.cosmo.css">

</head>

<body>

<div class="navbar navbar-default navbar-fixed-top navbar-inverse">
<div class="container">
	<div class="navbar-header">
		<a class="navbar-brand" href="index.html">Plaiframe Docs</a>
		<button class="navbar-toggle" type="button" data-toggle="collapse" data-target="#topNavigation">
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
        </button>
	</div>
	<div class="navbar-collapse collapse" id="topNavigation">
		<ul class="nav navbar-nav">
			
			<li class="dropdown">
				<a href="modules.list.html" class="dropdown-toggle" data-toggle="dropdown">Modules<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="module-errors.html">errors</a></li><li><a href="module-file.html">file</a></li><li><a href="module-game.html">game</a></li><li><a href="module-index.html">index</a></li><li><a href="module-medley.html">medley</a></li><li><a href="module-mongo.html">mongo</a></li><li><a href="module-ne.html">ne</a></li><li><a href="module-session.html">session</a></li><li><a href="module-variables.html">variables</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="classes.list.html" class="dropdown-toggle" data-toggle="dropdown">Classes<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="module-errors-DesignError.html">errors~DesignError</a></li><li><a href="module-game-Game.html">game~Game</a></li><li><a href="module-medley-Log.html">medley~Log</a></li><li><a href="module-medley-Queue.html">medley~Queue</a></li><li><a href="module-mongo-Database.html">mongo~Database</a></li><li><a href="module-mongo-Collection.html">mongo~Collection</a></li><li><a href="module-mongo-Document.html">mongo~Document</a></li><li><a href="module-ne-Database.html">ne~Database</a></li><li><a href="module-ne-Collection.html">ne~Collection</a></li><li><a href="module-ne-Document.html">ne~Document</a></li><li><a href="module-session-Session.html">session~Session</a></li><li><a href="module-variables-Variables.html">variables~Variables</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="externals.list.html" class="dropdown-toggle" data-toggle="dropdown">Externals<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="external-Object.html">Object</a></li>
				</ul>
			</li>
			
		</ul>
        
            <div class="col-sm-3 col-md-3">
                <form class="navbar-form" role="search">
                    <div class="input-group">
                        <input type="text" class="form-control" placeholder="Search" name="q" id="search-input">
                        <div class="input-group-btn">
                            <button class="btn btn-default" id="search-submit"><i class="glyphicon glyphicon-search"></i></button>
                        </div>
                    </div>
                </form>
            </div>
        
	</div>

</div>
</div>


<div class="container" id="toc-content">
<div class="row">

	
	<div class="col-md-12">
	
		<div id="main">
			

		<h1 class="page-title">Source: medley.js</h1>
    
<section>
    <article>
        <pre
            class="sunlight-highlight-javascript linenums">/**
* Contains useful unspecific classes and functions
* may be required by all PLAIT modules.
*
* @module medley
* @copyright Lasse Marburg 2020
* @license GPLv3
*/
const { EventEmitter } = require('events')
var npmlog = require('npmlog')
const fs = require('fs-extra')
const file = require('./file')


/**
* logging class based on [npmlog]{@link https://www.npmjs.com/package/npmlog}.
* Uses fs stream to write logs to logfile
*/
class Log {
	constructor() {
		npmlog.addLevel("debug",1000,{fg:"blue"})
		npmlog.addLevel("trace",500,{fg:"grey"})
        Object.assign(this, npmlog)
	}
	
	/**
	* initialise log write stream
	*/
	init(log_level) {
		return new Promise((resolve, reject) => {
			npmlog.level = log_level
			file.mkdir('./log')
			let date = this.getPrettyDate()
			date = date.replace(/\:/gm, "-").slice(0, -4)
			let logfile = './log/'+date+'.log'
			
			var logstream = fs.createWriteStream(logfile, {flags:'a'})
			logstream.on('open', res => {
				npmlog.on('log', l => {
					logstream.write(this.getPrettyDate() + ' ' + l.level.toUpperCase() + ' ' + l.prefix + ' ' + l.message + '\n')
				})
				return resolve()
			})
			
		})
	}
    
    /**
     * change current log level
     * - trace (show everything)
     * - debug
     * - log
     * - warn
     * - error
     * - silent (logging off)
     * @param {string} log_level 
     */
	setLevel(log_level) {
		npmlog.level = log_level
		console.log("log level changed to '" + log_level + "'")
    }
    
    /**
     * return current date time in following string format:
     * [year]-[month]-[day] [hour]-[minute]-[second]
     */
    getPrettyDate() {
        let tzoffset = (new Date()).getTimezoneOffset() * 60000 //offset in milliseconds
        return (new Date(Date.now() - tzoffset)).toISOString().slice(0, -1).replace('T', ' ')
    }
}

/**
 * Create an automated First in, first out queue. Runs a callback whenever something was added to the queue using the element as callback argument.
 * 
 * When callback is done queue will go on running the callback with the next items in stack until its.
 * 
 * @param {function} callback - function to call on each element in queue
 */
class Queue {
    constructor(callback) {
        /** argument item list */
        this.items = []

        /** function to be called on each item */
        this.callback = callback

        /** emits empty event */
        this.event = new EventEmitter()

        /** queue will not accept any more items when joined */
        this.joined = false

        log.debug("queue", "create queue with function " + callback.name)
    }

    /**
     * add an item to queue. If queue is empty, run callback right away with item as argument.
     * 
     * goto next once callback resolves
     * 
     * use return_callback to feedback the result of queue callback
     *
     * @param {*} item - argument for callback put into queue
     * @param {function} return_callback - is called with result arg once queue callback resolves
     */
    put(item, return_callback) {
        let elem = {
            "arg":item,
            "call":return_callback
        }
        if(this.joined) {
            return_callback(undefined)
            return
        }
        if(this.items.length == 0) {
            this.execute(elem)
        }
        this.items.push(elem)
    }

    execute(elem) {
        Promise.resolve(this.callback(elem["arg"]))
        .then(result => {
            elem.call(result)
            this.next()
        })
        .catch(err => {
            log.error("queue", "couldn't execute queued callback with next item")
            log.error("queue", err)
        })
    }

    /**
     * release latest element from queue. If there is another, run callback with next element.
     * 
     * When callback resolves, proceed with next element if any.
     * 
     * Emit empty event once there are no more elements enqueued
     */
    next() {
        if(this.items.length > 0) {
            this.items.shift()
        }
        
        if(this.items.length > 0) {
            this.execute(this.items[0])
        } else {
            this.event.emit('empty')
        }
    }

    /**
     * wait for queue to finish. Block adding of further elements until finished.
     *
     * @returns {Promise} - resolves once queue is done and empty
     */
    join() {
        return new Promise((resolve, reject) => {
            this.joined = true
            if(this.items.length > 0) {
                this.event.on('empty', e => {
                    this.joined = false
                    return resolve()
                })
            } else {
                this.joined = false
                return resolve()
            }
        })
    }

    /**
     * join queue but only wait for current item to finish.
     * Remove all leftover items.
     */
    cancel() {
        if(this.items.length > 1) {
            this.items = [this.items.shift()]
            log.debug("queue", "cancel and drop " + this.items.length + " items")
        }
        
        return this.join()
    }
}

/**
* Generate Unique Identifier String
*
* Thanks to this stackoverflow answer:
* {@link https://stackoverflow.com/questions/105034/create-guid-uuid-in-javascript/8809472#8809472}
* (Public Domain/MIT)
*/
global.generateUUID = function() {
    var d = new Date().getTime();
    if (typeof performance !== 'undefined' &amp;&amp; typeof performance.now === 'function'){
        d += performance.now(); //use high-precision timer if available
    }
    return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
        var r = (d + Math.random() * 16) % 16 | 0;
        d = Math.floor(d / 16);
        return (c === 'x' ? r : (r &amp; 0x3 | 0x8)).toString(16);
    });
}

/** 
 * The built in Object constructor
 * @external Object 
 * @see {@link https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object|Javascript Object}
 */

 
/**
* check if Object has any properties
* Checkout this post:
* https://coderwall.com/p/_g3x9q/how-to-check-if-javascript-object-is-empty
*
* @param {Object} obj - object to check on emptyness
*
* @returns {boolean} false if object is not empty
* @function external:Object#isEmpty
*/
Object.isEmpty = function(obj) {
    for(var key in obj) {
        if(obj.hasOwnProperty(key))
            return false
    }
    return true
}


/** 
 * see if a list of properties are all own properties of an object
 * 
 * @param {Object} obj - Object to review
 * @param {Array} properties - list of property names (each a string)
 *  
 * @returns {boolean} - true if all properties are own properties of object. Otherwise false
 * @function external:Object#hasOwnproperties
 */
Object.hasOwnProperties = function(obj, properties) {
    for (var i = 0; i &lt; properties.length; i++) {
        if (!obj.hasOwnProperty(properties[i]))
            return false
    }
    return true
}

/**
* address object property with '.' seperated string   
* Comes in handy especially when working with Mongodb and nested document find queries.  
* Mongo uses [dot notation]{@link https://docs.mongodb.com/manual/core/document/#document-dot-notation}
* Inspired by:
* {@link https://stackoverflow.com/questions/6491463/accessing-nested-javascript-objects-with-string-key/6491621#6491621}
*
* @param {Object} o - some Object
* @param {strin} s - some string that finds nested properties with '.' notation
* 
* @returns {*} - value or object that was found in '.' noted path. undefined if path doesn't exist in o
* @function external:Object#getPath
*/
Object.getPath = function(o, s) {
    s = s.replace(/\[(\w+)\]/g, '.$1') // convert indexes to properties
    s = s.replace(/^\./, '')          // strip a leading dot
    var a = s.split('.')
    for (var i = 0, n = a.length; i &lt; n; ++i) {
        var k = a[i]
        if(typeof o !== "object" || Array.isArray(o)) {
            log.warn("getPath", o + " is not a valid object")
            return
        }
        if (k in o) {
            o = o[k]
        } else {
            return
        }
    }
    return o
}

/**
* assign object property with '.' seperated string path
*
* Inspired by:
* {@link https://stackoverflow.com/questions/13719593/how-to-set-object-property-of-object-property-of-given-its-string-name-in-ja/13719799#13719799}
*
* @param {Object} obj - object to assign value to
* @param {string} prop - path
* @param {*} value - value to assign to object at path
*
* @function external:Object#assignPath
*/
Object.assignPath = function(obj, prop, value) {
    if (typeof prop === "string")
        prop = prop.split(".");

    if (prop.length > 1) {
        var e = prop.shift();
        Object.assignPath(obj[e] =
                 Object.prototype.toString.call(obj[e]) === "[object Object]"
                 ? obj[e]
                 : {},
               prop,
               value);
    } else {
			obj[prop[0]] = value;
		}
}

/**
* check if Objects have the same key/value pairs (keys also have to be in the same Order)
* Simple string comparison
* @todo find a more efficient and safe way then JSON.stringify comparison
* @param {Object} objA - compare Object A
* @param {Object} objB - compare Object B
* @function external:Object#equalValues
*/
Object.equalValues = function(objA, objB) {
	if(JSON.stringify(objA) == JSON.stringify(objB)) {
		return true
	} else {
		return false
	}
}

/**
* compare two objects and return what changes happended during the transition from
* one object to the other. Checks for equality in each property and recognises if
* a property has changed (updated), is new (updated) or was removed.
*
* @param {Object} original - Original object
* @param {Object} changed - Object that derived from original Object
*
* @returns {Object} 'updated' contains all keys and their values that are not equal or have
* no equal key - value pair in the original object. 'removed' contains a list of all missing properties
* in the changed object
* @function external:Object#changes
*/
Object.changes = function(original_object, changed_object) {
	let changes = {updated:{},removed:[]}
	for(let key in original_object) {
		if(changed_object.hasOwnProperty(key)) {
			if(!Object.equalValues(changed_object[key], original_object[key])) {
				changes.updated[key] = changed_object[key]
			}
		} else {
			changes.removed.push(key)
		}
	}
	for(let key in changed_object) {
		if(!original_object.hasOwnProperty(key)) {
			changes.updated[key] = changed_object[key]
		}
	}
	return changes
}

/**
* make an object clone using serialization. Leave no references even in nested properties.
* This does not work with complex object properties like functions, classes, dates etc.!
*
* @param {Object} source - Object to be deep cloned
*
* @returns {Object} - clone of object
* @function external:Object#deepClone
*/
Object.deepClone = function(source) {
    return JSON.parse(JSON.stringify(source))
}

/**
* perform a function on all Object properties, including nested properties.
* 
* is not being used to date.
*
* similar to, though way more primitive than, lodash {@link https://lodash.com/docs/4.17.15#transform|_transform}
* @param {Object} obj - Object to be transformed
* @param {function} funct - function to perform on Object properties
* @function external:Object#transform
*/
Object.transform = function(obj,funct) {
    var result = null;
    if(obj instanceof Array) {
        for(var i = 0; i &lt; theObject.length; i++) {
            result = Object.transform(obj[i], funct)
            if (result) {
                break
            }   
        }
    } else {
        for(var prop in obj) {
						funct(prop, obj)
            if(obj[prop] instanceof Object || obj[prop] instanceof Array) {
                result = Object.transform(obj[prop], funct)
                if (result) {
                    break
                }
            } 
        }
    }
    return result
}

module.exports = {
    Log: Log,
    Queue, Queue,
	generateUUID: generateUUID
}
</pre>
    </article>
</section>





		</div>
	</div>

	<div class="clearfix"></div>

	

</div>
</div>


    <div class="modal fade" id="searchResults">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <h4 class="modal-title">Search results</h4>
          </div>
          <div class="modal-body"></div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
          </div>
        </div><!-- /.modal-content -->
      </div><!-- /.modal-dialog -->
    </div>


<footer>

	 | <a href='https://plaitools.gitlab.io/documentation/plaiframe/webview/'>Webview Documentation</a> | <a href='https://plaitools.gitlab.io/documentation/plaiframe/plugins/'>Plugin Documentation</a> | <a href='https://gitlab.com/plaitools'>Plaitools on Gitlab</a>


	<span class="copyright">
	© 2020 Lasse Marburg, Benedikt Kaffai
	</span>

<span class="jsdoc-message">
	Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.4</a>
	
		on Fri Feb 5th 2021
	
	using the <a href="https://github.com/docstrap/docstrap">DocStrap template</a>.
</span>
</footer>

<script src="scripts/docstrap.lib.js"></script>
<script src="scripts/toc.js"></script>

    <script type="text/javascript" src="scripts/fulltext-search-ui.js"></script>


<script>
$( function () {
	$( "[id*='$']" ).each( function () {
		var $this = $( this );

		$this.attr( "id", $this.attr( "id" ).replace( "$", "__" ) );
	} );

	$( ".tutorial-section pre, .readme-section pre, pre.prettyprint.source" ).each( function () {
		var $this = $( this );

		var example = $this.find( "code" );
		exampleText = example.html();
		var lang = /{@lang (.*?)}/.exec( exampleText );
		if ( lang && lang[1] ) {
			exampleText = exampleText.replace( lang[0], "" );
			example.html( exampleText );
			lang = lang[1];
		} else {
			var langClassMatch = example.parent()[0].className.match(/lang\-(\S+)/);
			lang = langClassMatch ? langClassMatch[1] : "javascript";
		}

		if ( lang ) {

			$this
			.addClass( "sunlight-highlight-" + lang )
			.addClass( "linenums" )
			.html( example.html() );

		}
	} );

	Sunlight.highlightAll( {
		lineNumbers : true,
		showMenu : true,
		enableDoclinks : true
	} );

	$.catchAnchorLinks( {
        navbarOffset: 10
	} );
	$( "#toc" ).toc( {
		anchorName  : function ( i, heading, prefix ) {
			return $( heading ).attr( "id" ) || ( prefix + i );
		},
		selectors   : "#toc-content h1,#toc-content h2,#toc-content h3,#toc-content h4",
		showAndHide : false,
		smoothScrolling: true
	} );

	$( "#main span[id^='toc']" ).addClass( "toc-shim" );
	$( '.dropdown-toggle' ).dropdown();

    $( "table" ).each( function () {
      var $this = $( this );
      $this.addClass('table');
    } );

} );
</script>



<!--Navigation and Symbol Display-->


<!--Google Analytics-->



    <script type="text/javascript">
        $(document).ready(function() {
            SearcherDisplay.init();
        });
    </script>


</body>
</html>
